<?php

include('fn_sufx.inc');
$t_inizio=time();

@mkdir('temp',777);

if (!isset($type)) {
   echo "<a href='scan-dir.php'>scan for files</a><br>
         <a href='powerpoint2.php?type=x'>create the .ppt</a><br>";
   exit;
   }



function fn_compreso ($a,$x,$b) {   // x  compreso fra a e b?
  if ($a <= $x and $x <= $b) return true;
  else                       return false;
}

function fn_val_arpos ($ar_shape_pos, $i, &$x, &$y, &$dx, &$dy) {
   $x=  $ar_shape_pos[$i][0];
   $y=  $ar_shape_pos[$i][1];
   $dx= $ar_shape_pos[$i][2];
   $dy= $ar_shape_pos[$i][3];
}

function fn_dir ( $ar_shape_pos, $i, $r ) {   // valuta sovrapposizione degli oggetti

    fn_val_arpos ($ar_shape_pos, $i, $ix, $iy, $dix, $diy);

    $dix= $dix*1.5;   // percentuale di sovrapposizione: >1 simula una dimensione maggiore dell'oggetto (v. cellpadding)
    $diy= $diy*1.5;

    fn_val_arpos ($ar_shape_pos, $r, $fx, $fy, $dfx, $dfy);


    if (( fn_compreso( $ix-$dix, $fx, $ix+$dix)
          or  fn_compreso($ix-$dix, $fx+$dfx, $ix+$dix) )
          and
         ( fn_compreso($iy-$diy, $fy, $iy+$diy)
         or  fn_compreso($iy-$diy, $fy+$dfy, $iy+$diy) )) $y= 1 ;
    else   $y=0;

    //if ($y==1) fn_debug("sovrapposti: i=$i, r=$r");

    return $y;
}


function fn_connectpos ( $ar_shape_pos, $i, $cpos ) {

   fn_val_arpos ($ar_shape_pos, $i, $ix, $iy, $dx, $dy);

   if ($cpos==1) $y=array($ix+$dx/2, $iy);
   if ($cpos==2) $y=array($ix, $iy+$dy/2);
   if ($cpos==3) $y=array($ix+$dx/2, $iy+$dy);
   if ($cpos==4) $y=array($ix+$dx, $iy+$dy/2);

   return $y;

}


function fn_dir2 ( $ar_shape_pos, $i, $r ) {
   $y2= 1000000000000;
   for ( $pi = 1; $pi <= 4 ; $pi++ ) {
      for ( $pf = 1; $pf <= 4 ; $pf++ ) {
           $ari = fn_connectpos($ar_shape_pos, $i, $pi);
           $arf = fn_connectpos($ar_shape_pos, $r, $pf);

           $y[$pi][$pf]= sqrt(pow ($ari[0]-$arf[0],2)+ pow ($ari[1]-$arf[1],2));
           if ($y2 > $y[$pi][$pf]) {
               $y2= $y[$pi][$pf] ;
               $yk=array($pi,$pf);
               }
      }
   }

   //print_r ($y);
   //print_r ($yk);

   return $yk;
}



function fn_sposta( &$ar_shape_pos, $i, $xmed, $ymed, $stepx=1, $stepy=1) {
global $xmax, $ymax, $obi;
    $kx= 5*$stepx;
    $ky= 5*$stepy;
    $x= $ar_shape_pos[$i][0];
    $y= $ar_shape_pos[$i][1];

    $maxy_prosp =  $obi['Y_A'][$i];
    $miny_prosp =  $obi['Y_DA'][$i];

    $alfa= atan2($x-$xmed, $y-$ymed);
    $nx = $x+ sin($alfa)* $kx;
    $ny = $y+ cos($alfa)* $ky;
    if ($nx >= 50 and $nx + $ar_shape_pos[$i][2]<= $xmax ) $ar_shape_pos[$i][0] = $nx;
    else {
       //fn_debug("non potuto spostare: i=$i, x=$x nx=$nx xmax=$xmax");
       $nx = $x- sin($alfa)* $kx;
       $ar_shape_pos[$i][0] = $nx;
       }
    if ($ny >= $miny_prosp and $ny + $ar_shape_pos[$i][3]<= $maxy_prosp ) $ar_shape_pos[$i][1] = $ny;
    else {
       //fn_debug("non potuto spostare: i=$i, y=$y ny=$ny ymax=$ymax");
       $ny = $y- cos($alfa)* $ky;
       //$ar_shape_pos[$i][1] = $ny;
       }

    //fn_debug( "--spostato $i--");
}


function fn_sposta_sovrapposti(&$ar_shape_pos, $kx=0.5, $ky=0.5) {
//----------------------------------------------------------------
// sposta elementi sovrapposti in direzione eccentrica
global $nr_obi, $xmed, $ymed;
for ( $n = 2; $n >0; $n-- ) {    // parto con spostamenti maggiori -> minori
     for ( $i = 0; $i < $nr_obi; $i++ ) {
        for ( $r = 0; $r < $nr_obi; $r++ ) {
            if ($i!=$r) {
                  //echo "--i=$i, r=$r --"; flush();
                  if (fn_dir( $ar_shape_pos, $i, $r) == 1 ) {
                      $d1 = sqrt(pow(($ar_shape_pos[$i][0]-$xmed),2)+pow(($ar_shape_pos[$i][1]-$ymed),2));
                      $d2 = sqrt(pow(($ar_shape_pos[$r][0]-$xmed),2)+pow(($ar_shape_pos[$r][1]-$ymed),2));

                      if ($d1>$d2) fn_sposta($ar_shape_pos, $i, $xmed, $ymed, $n*$kx, $n*$ky);
                      else         fn_sposta($ar_shape_pos, $r, $xmed, $ymed, $n*$kx, $n*$ky);
                      //dei 2 sovrapposti sposta il pi lontano dal centro
                  }
            }
        }
     }
}
}




//------------------------------------------------ main -------------------------


$nome= md5(time());

set_time_limit(120);

$ppt =new COM("PowerPoint.application" ) or die("Cannot start powerpoint");

//print "Loaded powerpoint version ($ppt->Version)\n";

//$ppt->Application->Visible = 1;

$pres = $ppt->presentations->Add();

$slide= $pres->Slides->add(1, 12 );

$xmax= $slide->master->Width;
$ymax= $slide->master->height;
$xmed=0;
$ymed=0;

if ( $FromScript == 'menu' )
   if ( isset($cook_rep_pdc) ) $ID_PDC = $cook_rep_pdc;
   else $ID_PDC = $cook_id_pdc;

$se= "select * from vw_grafo_g order by g_ord";

list ($nr_obi, $obi) = fn_select2($se, $db_type);

//print_r($obi);
//exit;

if ($nr_obi==0)  {
    echo "<script> window.focus(); window.alert('nessun grafo da rappresentare'); close(); </script>";
    exit;
    }


$ar_shape=array();
$ar_shape_pos=array();
$dimx= 0.7;
$dimy= 1;


// calcola centro (media) grafico
for ( $i = 0; $i < $nr_obi ; $i++ ) {
     $descr=$obi['DESCR_OBI'][$i];

     $x=$obi['POS_X'][$i]*$dimx +150;
     $y=$obi['POS_Y'][$i]*$dimy +80;
     $lx=$ppt_box_width;
     $ly= (floor(strlen($descr)/60)+1)* $ppt_box_height;

     $xmed += $x+$lx/2;
     $ymed += $y+$ly/2;

     $ar_shape_pos[$i]= array($x,$y,$lx,$ly);

}
$xmed=$xmed/$nr_obi;
$ymed=$ymed/$nr_obi;


fn_sposta_sovrapposti($ar_shape_pos);

// ------------  crea box in powepoint
for ( $i = 0; $i < $nr_obi ; $i++ ) {
     $descr=$obi['DESCR_OBI'][$i];

     //echo "$descr <br>";

     $temp=substr($descr,0,5);
     $slide_link = fn_myhref($temp,$descr);

     if (strstr($descr,':'))      $slide_link = str_replace ('http:','http://',$descr);
     else if ($ppt_relative_href) $slide_link = $descr;
          else                    $slide_link = "file:///$nomedir$descr";


     list( $prfx , $sufx) = fn_sufx($descr);
     if ($sufx=='html') $descr=$prfx;
     if ($temp=='http:' and strlen($descr)>5) $descr=substr($descr,5);

     fn_val_arpos ($ar_shape_pos, $i, $x, $y, $lx, $ly);

     $shape= $slide->Shapes->AddShape(1, $x, $y, $lx, $ly );

     $shape->textframe->textrange->text= $descr;  // . ' '. $i;
     //$shape->textframe->textrange->text= "x=$y,y=$y,lx=$lx,ly=$ly";

     $shape->textframe->wordwrap = -1;
     $shape->textframe->textrange->font->size= $ppt_font_size;
     $shape->textframe->textrange->font->name = 'Arial';

     //$shape->alternativetext= $obi['DESCRESTESA'][$i];  // non si vede cmq

     $col = hexdec('f2f4a4');   $grad = false;
     if ($sufx =='jpg')                 $col = hexdec('a4f4f2');
     if ($sufx =='png')                 $col = hexdec('a8fcfe');
     if ($sufx =='gif')                 $col = hexdec('b0e8e8');
     if ($sufx =='css')                 $col = hexdec('c0c0c0');
     if ($sufx =='zip')  {              $col = hexdec('808080');  $grad = true; }

     if ( preg_match("/_e$/", $prfx) )  $col = hexdec('a4a0f2');  // just my convention for some file naming
     if ( strstr ($prfx, '\\'))         $col = hexdec('80f8f8');
     if ( strstr ($prfx, 'mailto:')) {  $col = hexdec('40d040');  $grad = true; }
     if ( strstr ($prfx, 'http:'))   {  $col = hexdec('d020d0');  $grad = true; }
     if (substr($prfx,0,2)=='..')       $col = hexdec('a09080');
     if ($prfx=='index')                $col = hexdec('0000ff');  // this is M$'red;;

     $shape->fill->forecolor->RGB= $col;
     if ($grad) $shape->fill->TwoColorGradient(2,1);

     $action= $shape->actionsettings->item(1);

     if ($slide_link!='') $action->hyperlink->address = $slide_link;

     $ar_shape [$i]= $shape;
}


// --------------  crea link
for ( $i = 0; $i < $nr_obi; $i++ ) {
    if ( $obi['OB_SUCC'][$i]!='' ) {
       $exp_obi=explode(",",$obi['OB_SUCC'][$i]);
       $exp_link_i_x=explode(",",$obi[LINK_I_X][$i]);
       $exp_link_i_y=explode(",",$obi[LINK_I_Y][$i]);
       for ( $k = 0; $k < count($exp_obi); $k++ ) {
           $ob_succ=$exp_obi[$k];
           $ix=$exp_link_i_x[$k];
           $iy=$exp_link_i_y[$k];
           for ( $r = 0; $r < $nr_obi; $r++ ) {
               if ( $obi[COD][$r]==$ob_succ ) {
                  $exp_ob_prec=explode(",",$obi[OB_PREC][$r]);
                  $exp_link_f_x=explode(",",$obi[LINK_F_X][$r]);
                  $exp_link_f_y=explode(",",$obi[LINK_F_Y][$r]);
                  break;
               }
           }

           //echo "r=$r";

           for ( $r2 = 0; $r2 < count($exp_ob_prec); $r2++ ) {
               $ob_prec=$exp_ob_prec[$r2];
               $fx=$exp_link_f_x[$r2];
               $fy=$exp_link_f_y[$r2];
               if ( $ob_prec==$obi[COD][$i] ) break;
           }

           //echo "$ix,$iy,$fx,$fy -- i=$i,k=$k,r=$r <br>";
           $connector=$slide->shapes->addconnector(3, $ix* $dimx ,$iy * $dimy , $fx* $dimx ,$fy * $dimy );

           $ar_dir= fn_dir2( $ar_shape_pos, $i, $r);

           $se="select conta, l_type from vw_connector_color where cod_gruppo={$obi[COD][$i]} and l_cod_gruppo={$obi[COD][$r]} ";
           list($n,$ris)=fn_select2($se, $db_type);

           if ($ris[CONTA][0]!='') $connector->Line->ForeColor->RGB= $ris[CONTA][0];
           else echo "?? $se";

           if ($ris[L_TYPE][0]==2) $connector->Line->Dashstyle= 5;


           $connector->ConnectorFormat->BeginConnect($ar_shape[$i], $ar_dir[0]);


           if ($r<$nr_obi) $connector->ConnectorFormat->EndConnect  ($ar_shape[$r], $ar_dir[1]);


           $connector->line->endarrowheadstyle=2;
           $connector->line->endarrowheadwidth=3;
           $connector->line->endarrowheadlength=3;

       }
    }
}


//fn_sposta_sovrapposti($ar_shape_pos,2,0);  // modif. solo coord x


$pres->SaveAs ( getcwd()."\\temp\\$nome");


echo "
<html><title>scanning dir $nomedir</title>
<style>
  .ourpref { font-family:arial; }
  .title1  { text-align:center; font-size:135%; font-family:arial; }
  .nota    { font-family:arial; font-size:80%; }
</style>
<div class=ourpref>

 <iframe src='temp/$nome' width=100% height=90%></iframe>

<p class=nota>elapsed=".(time()-$t_inizio) ." sec <br> db=$db_type
</div></html>";



?>

